#if (defined(HAVE_PROTOTYPES))
#if (!defined(PROTO_H_))
#define PROTO_H_

#include <sys/types.h>
#include <pcap.h>
#if (!defined(linux))
#include <kvm.h>
#endif
#include "queue.h"
#include "ipex.h"
#if (!defined(linux))
#include "proc_kvm.h"
#endif

#if	(defined(__STDC__))
#define _PRTYPE_(function, params)    function params
#else
#define _PRTYPE_(function, params)    function()
#endif /* defined(__STDC__) */

/* DEV_MEM_OPS_C */
_PRTYPE_(extern int get_dev_mem_op, (char *key));
_PRTYPE_(extern struct core *proc_args, (char *arg));

/* DUMP_BPF_C */
_PRTYPE_(extern void dump_struct_bpf_program, (struct bpf_program *p));

/* ICMP_PRINT_C */
_PRTYPE_(extern char *get_icmp_type, (unsigned char icmp_t));
_PRTYPE_(extern int print_icmp,	(register u_char *b, register struct pcap_pkthdr *h, register u_char *p));

/* IGMP_PRINT_C */
_PRTYPE_(extern int print_igmp, (register u_char *b, register struct pcap_pkthdr *h, register u_char *p));

/* IPEX_C */
_PRTYPE_(extern void cleanup, (void));
_PRTYPE_(extern int get_proto_printer, (u_char proto, int caplen));
_PRTYPE_(extern int datalink_lookup_offset, (pcap_t *p));
_PRTYPE_(extern void delegate, (u_char *pargs, register struct pcap_pkthdr *h, u_char *p));
_PRTYPE_(extern int usage, (char *base));
_PRTYPE_(extern int version, (void));
_PRTYPE_(extern void write_current_statistics, (void));

/* LINK_PRINT_C */
_PRTYPE_(extern struct ehdr *process_link_headers, (register u_char *u, register const struct pcap_pkthdr *h, register const u_char *p));

/* MPLEX_C */
_PRTYPE_(extern char ** mplex_arg_proc, (char *arg));

/* PRINT-ASCII_C */
_PRTYPE_(extern void ascii_print_with_offset, (register const u_char *cp, register u_int length, register u_int oset, register int fd));

#if (!defined(linux))
/* PROC_KVM_C */
_PRTYPE_(extern void queue_logic, (char *pcap_logic));
_PRTYPE_(extern void flush_logic, (void));
_PRTYPE_(extern char *compile_logic_list, (void));
_PRTYPE_(extern void scan_descriptor_tables, (char *buf));
_PRTYPE_(extern void process_descriptors, (kvm_t *fp));
_PRTYPE_(extern int kread, (kvm_t *addr, char *buf, size_t len));
_PRTYPE_(extern void process_socket, (void *data));
_PRTYPE_(extern int process_op_scan, (register struct proc *p, register struct core *uap));
#endif

/* SIGNALS_C */
_PRTYPE_(extern void rehashconf, (void));
_PRTYPE_(extern void transmit_sigint, (void));
_PRTYPE_(extern int handle_signals, (void));

/* TCP_PRINT_C */
_PRTYPE_(extern int print_tcp, (register unsigned char *data, register struct pcap_pkthdr *h, register unsigned char *p));
_PRTYPE_(extern char *print_addr_fmt, (struct in_addr addr, unsigned int flags));
_PRTYPE_(extern unsigned long int timer_secs, (char *arg));
_PRTYPE_(extern void set_timer, (char *arg));
_PRTYPE_(extern void isvalid, (char *expr));

/* UDP_PRINT_C */
_PRTYPE_(extern int print_udp, (u_char *b, struct pcap_pkthdr *h, u_char *p));

/* UTIL_C */
_PRTYPE_(extern int inet_write, (register int fd, register const char *fmt, ...));
_PRTYPE_(extern char *time_stamp, (register const struct timeval *tvp, int32_t zone));
_PRTYPE_(extern int32_t gmt2local, (time_t t));
_PRTYPE_(extern void text_dump, (register char *data, register int len, int fd));
_PRTYPE_(extern char *retbuf, (register char *p));
_PRTYPE_(extern int grep, (char *pattern, char *buf, int fd));
_PRTYPE_(extern void reg_error, (int msg, int fd));
_PRTYPE_(extern int strtolower, (register char *string));
_PRTYPE_(extern int strisdigit, (register char *string));
_PRTYPE_(extern void logic_load, (char *p, FILE *fp));
_PRTYPE_(extern void prescan_pcap_expr, (char *expr));
_PRTYPE_(extern char *retrive_pcap_expr, (char **argv));
_PRTYPE_(extern int strisdigit, (register char *string));
_PRTYPE_(extern char *cache_ns_entry, (u_32_t *ip));
_PRTYPE_(extern char *hostname, (int res, int v, u_32_t  *ip));
_PRTYPE_(extern void flush_ns_cache, (void));
_PRTYPE_(extern void *memalloc, (unsigned int n));
_PRTYPE_(extern void *memrealloc, (void *ptr, unsigned int n));

/* BSTREAM_C_ */

void    links_signodes __P((const char *fname));
char    **ParseLine __P((char *udata));
void    SignatureQueue __P((unsigned char *signature, char *debugmsg, int level, int (*functionp)(), int len, int id));
void    strip __P((char *from, char *to, int b, int max));
char    *upcase __P((char *str));
unsigned char
        string_to_hex __P((char *digits));
int     scan_signature __P((unsigned char *payload, unsigned int len));
void    flush_signatures __P((void));
int     test_alert __P((unsigned char *payload, struct signodes *matched));
int     xmemcmp __P((const void *s1, const void *s2, size_t n));
void	init_tabs __P((void));
char	*getproto __P((u_int p));
int	generic_print __P((register u_char *b, register struct pcap_pkthdr *h, register u_char *p));
char	*portname(int res, char *proto, u_int port);
void	yyerror(char *msg);
int	readtimespec(const char *string);
void	dump_and_trunc(u_char *user, const struct pcap_pkthdr *h, const u_char *sp);
u_long	parseCflag(char *Cflagstr);

#endif
#endif 
