/*
 *----------------------------------------------------------------------------
 * Copyright (c) 2001, 2002, C.S. Peron
 * All rights reserved.
 *----------------------------------------------------------------------------
 *
 *  * Redistribution and use in source and binary forms, with or without 
 *    modification, are permitted provided that the following conditions
 *    are met:
 *
 *  * Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 *  * Redistributions in binary form must reproduce the above 
 *    copyright notice, this list of conditions and the following disclaimer 
 *    in the documentation and/or other materials provided with the
 *    distribution.
 *
 *  * Neither the name of the ipex developers nor the names of its contributors 
 *    may be used to endorse or promote products derived from this software 
 *    without specific prior written permission. 
 *
 *----------------------------------------------------------------------------
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE 
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 
 * OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, 
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE 
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *----------------------------------------------------------------------------
 */

#ifndef lint
static const char rcsid[] = \
    "@(#) $Header: /usr/cvs/ipex24000/signals.c,v 1.3 2004/08/05 22:45:55 modulus Exp $";
#endif

#include "ipex_includes.h"

void 
rehashconf()
{
	/*
	 * This is here for DEBUG'ing purposes only, replace with
	 * real ruleset rehash
	 */
	printf( "DEBUG: >>> Caught HUP - Rehashing <<<\n");
}

void 
transmit_sigint()
{
	raise(SIGINT);
}

int 
handle_signals()
{
	struct sigaction sighup, sigint, sigusr;

	sighup.sa_handler = (void *)rehashconf;
	sighup.sa_flags = SA_NOCLDWAIT;
	sigint.sa_handler = (void *)cleanup;
	sigint.sa_flags = SA_NOCLDWAIT;
	sigusr.sa_handler = (void *)write_current_statistics;;
	sigusr.sa_flags = SA_NOCLDWAIT;
	sigaction(SIGINT,  &sigint, NULL);
	sigaction(SIGHUP,  &sighup, NULL);
	sigaction(SIGUSR1, &sigusr, NULL);
	return (0);
}
